<?php

# Codice Fiscale
# Ported from C++ to PHP on 03/07/05
# by Alessandro Rosa

# e-mail : zandor_zz@yahoo.it
# site : http://malilla.supereva.it

# Copyright (C) 2006  Alessandro Rosa

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# Compiled with PHP 4.4.0

require_once(dirname(__FILE__)."/ini_fn.php" );

$durata_mesi_ext = array( 31 , 28 , 31 , 30 , 31 , 30 , 31 , 31 , 30 , 31 , 30 , 31 ) ; 
$durata_mesi_ext_bisestile = array( 31 , 29 , 31 , 30 , 31 , 30 , 31 , 31 , 30 , 31 , 30 , 31 ) ; 

$vocali = array( "a", "e", "i", "o", "u" );

class cf
{

/* Variabili globali per la composizione del codice fiscale */

var $error_code = 0 ;
var $error_str = "" ;
var $codice_fiscale_str = "" ;

var $consonanti_nome = "" ;	var $consonanti_nome_num = 0 ;
var $vocali_nome = "" ;		var $vocali_nome_num = 0 ;
	
var $consonanti_cognome = "" ;	var $consonanti_cognome_num = 0 ;
var $vocali_cognome = "" ;		var $vocali_cognome_num = 0 ;
	
var $token_nome = "";	var $token_cognome = "";
	
var $nome = "";
var $cognome = "";
var $luogo_di_nascita = "";

var $data_di_nascita = 0 ;
var $sesso = 0 ;				//0 = Maschile, 1 = Femminile


// Methods:

function cf()
{
}

function IsBisestile( $anno )
{
    if ( ( $anno % 4 == 0 && $anno % 100 != 0 ) || $anno % 400 == 0 ) return 1 ;
    else return 0 ;
}

function ottieni_mese( $mese_index )
{
    $mese_verbose = "" ;

    switch ( $mese_index )
    {
        case 1:
            $mese_verbose = "Gennaio" ;
        break;
        case 2:
            $mese_verbose = "Febbraio" ;
        break;
        case 3:
            $mese_verbose = "Marzo" ;
        break;
        case 4:
            $mese_verbose = "Aprile" ;
        break;
        case 5:
            $mese_verbose = "Maggio" ;
        break;
        case 6:
            $mese_verbose = "Giugno" ;
        break;
        case 7:
            $mese_verbose = "Luglio" ;
        break;
        case 8:
            $mese_verbose = "Agosto" ;
        break;
        case 9:
            $mese_verbose = "Settembre" ;
        break;
        case 10:
            $mese_verbose = "Ottobre" ;
        break;
        case 11:
            $mese_verbose = "Novembre" ;
        break;
        case 12:
            $mese_verbose = "Dicembre" ;
        break;
        default:
            $mese_verbose = "Errore" ;
        break;
    }
    
    return $mese_verbose ;
}

function Reset_all()
{
	$error_code = 0 ;
	$error_str = "";
	
	$consonanti_nome_num = $vocali_nome_num = 0 ;
	$consonanti_cognome_num = $vocali_cognome_num = 0 ;
	$data_di_nascita = 0 ;

	$codice_fiscale_str = "" ;
	
	$nome = "" ;	$cognome = "" ;
	$consonanti_cognome = "" ;		$consonanti_nome = "" ;
	$vocali_nome = "" ;			$vocali_cognome = "" ;

	$luogo_di_nascita = "" ;
	$sesso = 1;
}

function inserisci_luogo_di_nascita( $comune_o_stato )
{
  $GLOBALS['luogo_di_nascita'] = str_replace( " ", "_", $comune_o_stato ) ;
}

function inserisci_nome( $nome_utente )
{
  $GLOBALS['nome'] = str_replace( " ", "", $nome_utente ) ;
}

function inserisci_cognome( $cognome_utente )
{
  $GLOBALS['cognome'] = str_replace( " ", "", $cognome_utente ) ;
}

function inserisci_anno_nascita( $anno )
{
  $anno %= 100 ;

  $data_di_nascita = $GLOBALS['data_di_nascita'] ;

	$data_di_nascita = $data_di_nascita & 0xFFFFFF00;
	$data_di_nascita = $data_di_nascita | $anno ;

  $GLOBALS['data_di_nascita'] = $data_di_nascita ;
}

function inserisci_mese_nascita( $mese )
{
  $data_di_nascita = $GLOBALS['data_di_nascita'] ;

	$data_di_nascita = $data_di_nascita & 0xFFFF00FF;
	$data_di_nascita = $data_di_nascita | ( $mese << 8 ) ;

  $GLOBALS['data_di_nascita'] = $data_di_nascita ;
}

function inserisci_giorno_nascita( $giorno )
{
  $data_di_nascita = $GLOBALS['data_di_nascita'] ;

	$data_di_nascita = $data_di_nascita & 0xFF00FFFF;
	$data_di_nascita = $data_di_nascita | ( $giorno << 16 ) ;

  $GLOBALS['data_di_nascita'] = $data_di_nascita ;
}

function inserisci_sesso( $sex )
{
	$GLOBALS['sesso'] = $sex ;
}

function IsVocale( $lettera )
{
	return in_array( $lettera, $GLOBALS['vocali'] ) ;
}

function estrai_nome()
{
	$input_len = strlen( $GLOBALS['nome'] );
	$vocali_trovate = 0;
  $consonanti_trovate = 0 ;

	for ( $count = 0 ; $count < $input_len ; $count++ )
	{
	  $l = $GLOBALS['nome'][$count] ;
	
		if ( $this->IsVocale( $l ) )
		{
			$GLOBALS['vocali_nome'] .= $l;
			$vocali_trovate++;
		}
		else
		{
			$GLOBALS['consonanti_nome'] .= $l;
			$consonanti_trovate++;
		}
	}
	
	$GLOBALS['vocali_nome_num'] = $vocali_trovate ;
	$GLOBALS['consonanti_nome_num'] = $consonanti_trovate ;
}

function estrai_cognome()
{
	$input_len = strlen( $GLOBALS['cognome'] ) ;
	$vocali_trovate = 0 ;
  $consonanti_trovate = 0 ;

	for ( $count = 0 ; $count < $input_len ; $count++ )
	{
	  $l = $GLOBALS['cognome'][$count] ;

		if ( $this->IsVocale( $l ) )
		{
			$GLOBALS['vocali_cognome'] .= $l;
			$vocali_trovate++;
		}
		else
		{
			$GLOBALS['consonanti_cognome'] .= $l;
			$consonanti_trovate++;
		}
	}
	
	$GLOBALS['vocali_cognome_num'] = $vocali_trovate ;
	$GLOBALS['consonanti_cognome_num'] = $consonanti_trovate ;
}

function risolvi_anno_nascita()
{
	$anno_num = $GLOBALS['data_di_nascita'] & 0xFF ;
	
	if ( $anno_num < 0 || $anno_num > 99 )
	{
		$GLOBALS['error_code'] = 6 ;
		$GLOBALS['error_str'] = "Campo 'Anno' errato" ;
		return "" ;
	}

	$anno = $anno_num ;

	if ( strlen( $anno ) == 1 ) $anno = "0" . $anno ;

	return $anno ;
}

function risolvi_giorno_nascita()
{
	$giorno = "";

	$giorno_num = ( $GLOBALS['data_di_nascita'] & 0xFF0000 ) >> 16 ;
	$mese_num = ( $GLOBALS['data_di_nascita'] & 0xFF00 ) >> 8 ;
	$anno_num = $GLOBALS['data_di_nascita'] & 0xFF ;

	$durata_mesi_ptr = array() ;
	if ( $this->IsBisestile( $anno_num ) ) $durata_mesi_ptr = $GLOBALS['durata_mesi_ext_bisestile'] ;
	else $durata_mesi_ptr = $GLOBALS['durata_mesi_ext'] ;
	
	if ( $mese_num  < 0 )
	{
		$GLOBALS['error_code'] = 4 ;
		$GLOBALS['error_str'] = "Campo 'Mese' errato." ;
		return "" ;
	}
	
	if ( $mese_num == 2 && !IsBisestile( $anno_num ) && $giorno_num == 29 )
	{
		$GLOBALS['error_code'] = 4 ;
		$GLOBALS['error_str'] = "L' anno '%d non  bisestile." ;
		printf( $GLOBALS['error_str'], anno_num );
		return "" ;
	}
	else if ( $giorno_num < 1 || $giorno_num > $durata_mesi_ptr[ $mese_num - 1 ] )
	{
		$GLOBALS['error_code'] = 4 ;
		$GLOBALS['error_str'] = "Il 'Giorno' non  nel 'Mese'." ;
		return "" ;
	}
	
	if ( $GLOBALS['sesso'] == 1 ) $giorno_num += 40 ;
	
	$giorno = $giorno_num ;
	if ( strlen( $giorno ) == 1 ) $giorno = "0" . $giorno ;
	
	return $giorno ;
}

function risolvi_mese_nascita()
{
	$mese = "" ;
	$mese_num = ( $GLOBALS['data_di_nascita'] & 0xFF00 ) >> 8 ;

	if ( $mese_num < 1 || $mese_num > 12 )
	{
		$GLOBALS['error_code'] = 5 ;
		$GLOBALS['error_str'] = "Campo 'Mese' errato." ;
		return "" ;
	}

	switch( $mese_num )
	{
			case 1:
				$mese = "A" ;
				break;
			case 2:
				$mese = "B" ;
				break;
			case 3:
				$mese = "C" ;
				break;
			case 4:
				$mese = "D" ;
				break;
			case 5:
				$mese = "E" ;
				break;
			case 6:
				$mese = "H" ;
				break;
			case 7:
				$mese = "L" ;
				break;
			case 8:
				$mese = "M" ;
				break;
			case 9:
				$mese = "P" ;
				break;
			case 10:
				$mese = "R" ;
				break;
			case 11:
				$mese = "S" ;
				break;
			case 12:
				$mese = "T" ;
				break;
			default:
				break;
	}

	$mese = strtolower( $mese ) ;
	return $mese ;
}

function risolvi_nome()
{
	if ( strlen( $GLOBALS['nome'] ) == 0 )
	{
		$GLOBALS['error_code'] = 1 ;
		$GLOBALS['error_str'] = "Il campo 'Nome'  vuoto." ;
		return "";
	}
	
	$this->estrai_nome();
	$token_count = 0 ;
	
	if ( $GLOBALS['consonanti_nome_num'] >= 4 )
	{
		for ( $count = 0 ; $count < 4 ; $count++ )
			if ( $count != 1 ) $GLOBALS['token_nome'] .= $GLOBALS['consonanti_nome'][$count];
	}
	else if ( consonanti_nome_num == 3 )
	{
		for ( $count = 0 ; $count < 3 ; $count++ )
			$GLOBALS['token_nome'] .= $GLOBALS['consonanti_nome'][$count];
	}
	else
	{
		$GLOBALS['token_nome'] .= substr( $GLOBALS['consonanti_nome'], 0, $GLOBALS['consonanti_nome_num'] );
		$GLOBALS['token_nome'] .= substr( $GLOBALS['vocali_nome'], 0, 3 - $GLOBALS['consonanti_nome_num'] );
	}

	while( strlen( $GLOBALS['token_nome'] ) < 3 )
	{
		$GLOBALS['token_nome'] .= "x" ;
	}

	return $GLOBALS['token_nome'];
}

function risolvi_cognome()
{
	if ( strlen( $GLOBALS['cognome'] ) == 0 )
	{
		$GLOBALS['error_code'] = 2 ;
		$GLOBALS['error_str'] = "Il campo 'Cognome'  vuoto." ;
		return "";
	}
	
	$this->estrai_cognome();
	$token_count = 0 ;

	if ( $GLOBALS['consonanti_cognome_num'] >= 3 )
	{
		for ( $count = 0 ; $count < 3 ; $count++ )
			$GLOBALS['token_cognome'] .= $GLOBALS['consonanti_cognome'][ $count ];
	}
	else
	{
		$GLOBALS['token_cognome'] .= substr( $GLOBALS['consonanti_cognome'], 0, $GLOBALS['consonanti_cognome_num'] );
		$GLOBALS['token_cognome'] .= substr( $GLOBALS['vocali_cognome'], 0, 3 - $GLOBALS['consonanti_cognome_num'] );
	}

	while( strlen( $GLOBALS['token_cognome'] ) < 3 )
	{
		$GLOBALS['token_cognome'] .= "x" ;
	}

	return $GLOBALS['token_cognome'] ;
}

function risolvi_luogo_di_nascita()
{
	if ( strlen( $GLOBALS['luogo_di_nascita'] ) == 0 )
	{
		$GLOBALS['error_code'] = 3 ;
		$GLOBALS['error_str'] = "Il campo 'Luogo'  vuoto." ;
		return "" ;
	}

	$luogo = strtoupper( $GLOBALS['luogo_di_nascita'] );
	$iniziale = $luogo{0};
	$ascii_code = ord($iniziale) ;

	$file_path = "Comuni" ;
	
	if		( $ascii_code >= 65 && $ascii_code <= 75 ) $file_path .=  "/comuniAK.ini" ;
	else if ( $ascii_code >= 76 && $ascii_code <= 77 ) $file_path .=  "/comuniLM.ini" ;
	else if ( $ascii_code >= 78 && $ascii_code <= 81 ) $file_path .=  "/comuniNQ.ini" ;
	else if ( $ascii_code == 82 ) $file_path .=  "/comuniR.ini" ;
	else if ( $ascii_code == 83 ) $file_path .=  "/comuniS.ini" ;
	else if ( $ascii_code >= 84 && $ascii_code <= 85 ) $file_path .=  "/comuniTU.ini" ;
	else if ( $ascii_code >= 86 && $ascii_code <= 90 ) $file_path .=  "/comuniVZ.ini" ;

	$luogo = get_params_ini( "Luogo", $luogo, $file_path ) ;
	
	if ( strlen( $luogo ) == 0 )
	{
		$GLOBALS['error_code'] = 7 ;
		$GLOBALS['error_str'] = "Codice del Luogo non trovato." ;
		return "" ;
	}
	
	$luogo = strtolower( $luogo );
	return $luogo ;
}

function restituisci_valore_lettera_pari( $lettera )
{
	$valore = 0 ;
	$lettera = strtoupper( $lettera );
	
	if		( $lettera == "0" ) $valore = 0 ;
	else if ( $lettera == "1" ) $valore = 1 ;
	else if ( $lettera == "2" ) $valore = 2 ;
	else if ( $lettera == "3" ) $valore = 3 ;
	else if ( $lettera == "4" ) $valore = 4 ;
	else if ( $lettera == "5" ) $valore = 5 ;
	else if ( $lettera == "6" ) $valore = 6 ;
	else if ( $lettera == "7" ) $valore = 7 ;
	else if ( $lettera == "8" ) $valore = 8 ;
	else if ( $lettera == "9" ) $valore = 9 ;
	else
	{
		$valore = ord( $lettera{ 0 } ); ;
		$valore -= 65 ;
	}

	return $valore ;
}

function restituisci_valore_lettera_dispari( $lettera )
{
	$valore = 0 ;
	$lettera = strtoupper( $lettera );
	
	if ( $lettera == "0" || $lettera == "A" ) $valore = 1 ;
	else if ( $lettera == "1" || $lettera == "B" ) $valore = 0 ;
	else if ( $lettera == "2" || $lettera == "C" ) $valore = 5 ;
	else if ( $lettera == "3" || $lettera == "D" ) $valore = 7 ;
	else if ( $lettera == "4" || $lettera == "E" ) $valore = 9 ;
	else if ( $lettera == "5" || $lettera == "F" ) $valore = 13 ;
	else if ( $lettera == "6" || $lettera == "G" ) $valore = 15 ;
	else if ( $lettera == "7" || $lettera == "H" ) $valore = 17 ;
	else if ( $lettera == "8" || $lettera == "I" ) $valore = 19 ;
	else if ( $lettera == "9" || $lettera == "J" ) $valore = 21 ;
	else if ( $lettera == "K" ) $valore = 2 ;
	else if ( $lettera == "L" ) $valore = 4 ;
	else if ( $lettera == "M" ) $valore = 18 ;
	else if ( $lettera == "N" ) $valore = 20 ;
	else if ( $lettera == "O" ) $valore = 11 ;
	else if ( $lettera == "P" ) $valore = 3 ;
	else if ( $lettera == "Q" ) $valore = 6 ;
	else if ( $lettera == "R" ) $valore = 8 ;
	else if ( $lettera == "S" ) $valore = 12 ;
	else if ( $lettera == "T" ) $valore = 14 ;
	else if ( $lettera == "U" ) $valore = 16 ;
	else if ( $lettera == "V" ) $valore = 10 ;
	else if ( $lettera == "W" ) $valore = 22 ;
	else if ( $lettera == "X" ) $valore = 25 ;
	else if ( $lettera == "Y" ) $valore = 24 ;
	else if ( $lettera == "Z" ) $valore = 23 ;

	return $valore ;
}

function risolvi_carattere_di_controllo()
{
	$sum = 0 ;
  $posto = 1;
	
  for ( $count = 0 ; $count < strlen( $GLOBALS['codice_fiscale_str'] ) ; $count++ , $posto++ )
	{
		if ( $posto % 2 == 0 ) $sum += $this->restituisci_valore_lettera_pari( $GLOBALS['codice_fiscale_str'][$count] );
		else $sum += $this->restituisci_valore_lettera_dispari( $GLOBALS['codice_fiscale_str'][$count] );
	}

	$controllo = chr( ( $sum % 26 ) + 97 );
	return $controllo;
}


/* /////////////////////////////////////////////// */
function componi_codice_fiscale()
{
	$GLOBALS['codice_fiscale_str'] = $this->risolvi_cognome();
	if ( $GLOBALS['error_code'] != 0 ) return ;	

	if ( $GLOBALS['error_code'] == 0 ) $GLOBALS['codice_fiscale_str'] .= $this->risolvi_nome();
	else return ;

	if ( $GLOBALS['error_code'] == 0 ) $GLOBALS['codice_fiscale_str'] .= $this->risolvi_anno_nascita() ;
	else return ;
	
	if ( $GLOBALS['error_code'] == 0 ) $GLOBALS['codice_fiscale_str'] .= $this->risolvi_mese_nascita() ;
	else return ;
	
	if ( $GLOBALS['error_code'] == 0 ) $GLOBALS['codice_fiscale_str'] .= $this->risolvi_giorno_nascita() ;
	else return ;
	
	if ( $GLOBALS['error_code'] == 0 ) $GLOBALS['codice_fiscale_str'] .= $this->risolvi_luogo_di_nascita() ;
	else return ;

	if ( $GLOBALS['error_code'] == 0 ) $GLOBALS['codice_fiscale_str'] .= $this->risolvi_carattere_di_controllo() ;
	else return ;
}

/* /////////////////////////////////////////////// */
function estrai_CF( $nome_utente , $cognome_utente ,
							       $giorno_nascita ,
							       $mese_nascita ,
							       $anno_nascita , 
								     $sex /* 0 - maschio , 1 - femmina */ ,
								     $comune_o_stato )
{
	$this->Reset_all();

	$nome_utente = strtolower( $nome_utente );
	$cognome_utente = strtolower( $cognome_utente );
	
	$this->inserisci_nome( $nome_utente );
	$this->inserisci_cognome( $cognome_utente );
	$this->inserisci_giorno_nascita( $giorno_nascita );
	$this->inserisci_mese_nascita( $mese_nascita );
	$this->inserisci_anno_nascita( $anno_nascita );
	$this->inserisci_sesso( $sex );
	$this->inserisci_luogo_di_nascita( $comune_o_stato );

	$this->componi_codice_fiscale();
	
	$GLOBALS['codice_fiscale_str'] = strtoupper( $GLOBALS['codice_fiscale_str'] );

  return $GLOBALS['codice_fiscale_str'] ;
}


}

?>
